"""Template for main.py file."""

MAIN_TEMPLATE = '''
"""
{{ project_name }} - FastAPI Application
Generated by BS FastAPI CLI
"""

from fastapi import FastAPI
from fastapi.middleware.cors import CORSMiddleware
from bs__connection.database import engine, Base
from bs__security.auth import get_current_user

# Import your routers here
# from routers.routeExample import router as example_router

# Create database tables
Base.metadata.create_all(bind=engine)

app = FastAPI(
    title="{{ project_name }}",
    description="FastAPI application generated by BS CLI",
    version="1.0.0"
)

# Configure CORS
app.add_middleware(
    CORSMiddleware,
    allow_origins=["*"],  # Configure this properly for production
    allow_credentials=True,
    allow_methods=["*"],
    allow_headers=["*"],
)

# Health check endpoint
@app.get("/")
async def root():
    return {"message": "{{ project_name }} is running!"}

@app.get("/health")
async def health_check():
    return {"status": "healthy"}

# Include routers here
# app.include_router(example_router, prefix="/api/v1", tags=["examples"])

if __name__ == "__main__":
    import uvicorn
    uvicorn.run(app, host="0.0.0.0", port=8000)
'''
